commit 7de78f7353f125663a22f5514159ea966a120049
Author: Jason Merrill <jason@redhat.com>
Date:   Tue Oct 22 16:37:49 2024 -0400

    c++: non-dep structured binding decltype again [PR117107]
    
    The patch for PR92687 handled the usual case of a decomp variable not being
    in the table, but missed the case of there being nothing in the table yet.
    
            PR c++/117107
            PR c++/92687
    
    gcc/cp/ChangeLog:
    
            * decl.cc (lookup_decomp_type): Handle null table.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp2a/decomp10.C: New test.
    
    (cherry picked from commit 71e13ea134b04562f8f2cdd9c4a55dbb0905f96a)

diff --git a/gcc/cp/decl.cc b/gcc/cp/decl.cc
index ca00e9aea20..d5cef069fce 100644
--- a/gcc/cp/decl.cc
+++ b/gcc/cp/decl.cc
@@ -9271,8 +9271,9 @@ static GTY((cache)) decl_tree_cache_map *decomp_type_table;
 tree
 lookup_decomp_type (tree v)
 {
-  if (tree *slot = decomp_type_table->get (v))
-    return *slot;
+  if (decomp_type_table)
+    if (tree *slot = decomp_type_table->get (v))
+      return *slot;
   return NULL_TREE;
 }
 
diff --git a/gcc/testsuite/g++.dg/cpp2a/decomp10.C b/gcc/testsuite/g++.dg/cpp2a/decomp10.C
new file mode 100644
index 00000000000..8fe425b5d01
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp2a/decomp10.C
@@ -0,0 +1,21 @@
+// PR c++/117107
+// { dg-do compile { target c++11 } }
+// { dg-options "" }
+
+template <typename, typename>
+constexpr bool is_same = false;	// { dg-warning "variable template" "" { target c++11_down } }
+template <typename T>
+constexpr bool is_same<T, T> = true; // { dg-warning "variable template" "" { target c++11_down } }
+
+struct tuple {
+  template <unsigned long I>
+  void check_tuple_like() {
+    tuple t;
+    auto [v, r] = t; // { dg-warning "structured bindings" "" { target c++14_down } }
+    (void)[v, r] {   // { dg-warning "captured structured" "" { target c++17_down } }
+        decltype(v) x;
+    };
+  }
+  int a = 0;
+  int &b = a;
+};

